
hirom
header

org $C2352B
; org $C23526  ; location in SFC version
; runic function
	LDA $11A3
	BIT #$08  ; can this spell by absorbed by Runic?
	BEQ no_runic
	STZ $EE
	STZ $EF
	LDY #$12
check_targets:
	LDA $3AA0,Y
	LSR A  ; is this a valid target?
	BCC check_remaining_targets
	PEA $80C0  ; sleep, petrify, death
	PEA $2210  ; freeze, hide, stop
	JSR $5864  ; check to see if this entity has any of these ailments
;	JSR $584C  ; check to see if this entity has any of these ailments, SFC version
	BCC check_remaining_targets  ; branch if any set
	LDA $3E4C,Y
	BIT #$06  ; perma runic or runic in play?
	BEQ check_remaining_targets
	REP #$20
	LDA $3018,Y  ; load this entity
	TSB $EE  ; mark this character to have runic removed later
	SEP #$20
check_remaining_targets:
	DEY
	DEY  ; have we run through all 10 entities yet?
	BPL check_targets  ; branch if not
	LDA $EE
	ORA $EF
	BEQ no_runic  ; branch if nobody has runic
	PHX
	JSR $3865
;	JSR $3860  ; SFC version
	STZ $3415
	JSR continue_runic
	STA $B8
	JSR $520E  ; X = number of targets
;	JSR $51F6  ; SFC version
	STZ $11AA  ; remove all status this attack sets
	STZ $11AC  ; remove all status this attack sets
	LDA #$2182
	STA $11A3
	SEP #$20
	LDA #$60
	STA $11A2  ; set to ignore defense and no split damage
	TDC  ; clean upper 8 bits
	LDA $11A5  ; MP cost
	JSR $4792  ; divide MP cost by X
;	JSR $477A  ; divide MP cost by X, SFC version
	STA $11A6  ; save as power
	STZ $11A1  ; remove all elemental properties for this attack
	JSR $385E
;	JSR $3859  ; SFC version
	STZ $3414  ; set to not modify damage
	LDA #$40
	TRB $B2
	LDA #$04
	STA $BA  ; don't retarget if target invalid
	DEC A
	TRB $11A7  ; turn off text and miss if status isn't set or clear
	STZ $11A9  ; set special affect to nothing
	PLX
no_runic:
	RTS

org $C2657D
continue_runic:
	LDA $BB
	BIT #$2C  ; can this spell be spread?
	REP #$20
	BNE runic_multi  ; branch if so
normal_runic:
	LDA $EE  ; otherwise load all runickers
	JSR $522A  ; pick one of them at random
;	JSR $5212  ; pick one of them at random, SFC version
	JSR $51F9  ; Y = target number of the bit set in A
;	JSR $51E1  ; Y = target number of the bit set in A, SFC version
remove_runic:
	PHA
	LDA $3E4C,Y
	AND #$FFFB  ; remove runic from this entity, perma runic still remains
	STA $3E4C,Y  ; save it
	PLA
	RTS

runic_multi:
	LDA $B8
	JSR $520E  ; X = number of targets
;	JSR $51F6  ; X = number of targets, SFC version
	DEX  ; decrement number of targets
	BEQ normal_runic  ; branch if only one, pick one of them at random
	LDX #$12
	LDA $EE  ; load all runickers
check_again_target2:
	BIT $3018,X  ; does this entity have runic?
	BEQ this_runic_no  ; branch if not
	TXY  ; let's not taint X
	JSR remove_runic
this_runic_no:
	DEX
	DEX
	BPL check_again_target2
	RTS
